﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Channels;
using System.ServiceModel;

namespace Router
{
    [ServiceBehavior(AddressFilterMode=AddressFilterMode.Any)]
    public class RouterService
        :IRouter
    {
        #region IRouter Members

        public Message ForwardMessage(Message message)
        {
            int headerIndex = message.Headers.FindHeader("Key", "http://www.plainconcepts.com");
            if (headerIndex != -1)
            {
                string host = message.Headers.GetHeader<string>(headerIndex);
                ChannelFactory<IRouter> client = new ChannelFactory<IRouter>(host);
                return (client.CreateChannel()).ForwardMessage(message);
            }

            throw new InvalidOperationException("No se puede encontrar la cabecera 'Key'");
        }

        #endregion
    }
}
